
#include "parseopt.h"
#include "rxx.h"
#include "cache.h"
#include "snapshot.h"

int cfsrw_verbose = 0;

void get_snapID (chordID sID, ptr<snapshot>) {
  warn << "Success!! Snapshot ID is " << sID << "\n";
}

int 
main (int argc, char **argv) 
{
  chordID vid;
  char *vstr = NULL;
  char *istr = NULL;
  char *dstr = NULL;
  char *fstr = NULL;
  setprogname (argv[0]);

  cfsrw_dhashclt::init();

  int ch;
  while ((ch = getopt (argc, argv, "V:i:d:f")) != -1) 
    switch (ch) {
    case 'V':
      vstr = optarg;
      break;
    case 'i':
      istr = optarg;
      break;
    case 'd':
      dstr = optarg;
      break;
    case 'f':
      fstr = optarg;
      break;
    default:
      break;
    }

  if (vstr) {
    char sym[1024];
    str dearm;
    rxx path_regexp ("chord:([0-9a-zA-Z+-]*)[/]*$");
    int r = readlink(vstr, sym, 1024);
    if (r > 0) sym[r] = '\0';
    if (path_regexp.search (vstr) || (r > 0 && path_regexp.search(sym)))
      dearm = dearmor64A(path_regexp[1]);
    else
      dearm = dearmor64A(vstr);
    mpz_set_rawmag_be(&vid, dearm.cstr(), dearm.len());

    New refcounted<snapshot>
      (vid, (chordID)0, (ptr<snapshot>)0, wrap (&get_snapID));
  } 
#if 0
  else {
    if (istr) {
      str dearm = dearmor64A(istr);
      chordID id;
      mpz_set_rawmag_be(&id, dearm.cstr(), dearm.len());

    }
  }
#endif
  amain ();
}
